INSTALLER-DIST(1)

NAME
installer-dist - download and import Whonix/Kicksecure VMs

SYNOPSIS
installer-dist options

DESCRIPTION
installer-dist is a wrapper that automates the download and importation of Kicksecure and Whonix VMs, on the interface you prefer such as CLI or Xfce, using the hypervisor of you choice, such as KVM or VirtualBox.

OPTIONS
Options starts with one or two dashes. Long and short options that require arguments accept being separated by spaces of an equal sign.

If the same option is specified multiple times, the last assignment will be used.

Guest and Interface can be set by changing the script name to the format guest-installer-interface.

-g, --guest=guest

        Set guest operating system. Options: kicksecure, whonix (default).

-u, --guest-version=version

        Set guest's version. Default to use API if none specified.

-i, --interface=interface

        Set guest's interface. Options: cli, xfce (default).

-m, --hypervisor=hypervisor

        Set guest's hypervisor. Options: kvm, virtualbox (default).

--oracle-repo

        Set Oracle repository for VirtualBox. Default for Fedora based
        distributions, optional for Debian based distributions, but may
        be set by the developers if the Debian repository stops serving
        the VirtualBox package.

-o, --onion

        Make requests over the onion network.

-s, --socks-proxy=proxy

        Set TCP SOCKS proxy for use in requests. Format: "host:addr". If
        none specified, but onion request is set, try
        TOR_SOCKS_HOST:TOR_SOCKS_PORT, if empty, try host 127.0.0.1 and
        default ports for TBB port 9151 and tor system port 9050.

-l, --log-level=level

        Set logging level. Options: debug, info, notice (default), warn,
        error. Everything below the selected logging level level will be
        printed.

-k, --no-boot

        Don't boot guest at the end of the run. Default is ask to start
        guest and if non-interactive is set, start guest by default.

--no-import

        Don't import guest. Default is to import if not already imported.

--import-only=vm

        Import only a single Virtual Machine when the guest is whonix.
        Options: gateway, workstation.

--redownload

        Set option to force download even if flag of previous
        successfull download already exists.

--reimport

        Redo the import of the guest to the hypervisor. Will try to import
        already existing files if found. This option requires
        --destroy-existing-guest as pledge.

--destroy-existing-guest

        Required pledge for --reimport.

-P, --directory-prefix=directory

        Set absolute path directory to save downloaded files to. Default to
        $HOME/installer-dist-download. The directory must already exist
        and have read and write capabilities for the calling user. If you
        change this directory, but the previously downloaded files are not
        changed to the new directory, the download starts again.

-n, --non-interactive

        Set non-interactive mode, instead of questions, defaults will be
        assumed, including accepting the license and starting the guest.

--mirror=number

        Set mirror acording to number index. Choose closest mirror to
        you if not using onion for faster downloads.  Not that if not
        choosing mirror, defaults to whonix.org for plainnet and
        dotsrc.org correspondent for onion.
        Mirrors index:
          0 [DE] download.whonix.org (onion available)
          1 [DK] mirrors.dotsrc.org (onion available)
          2 [DE] mirror.koljasagorski.de
          3 [HU] quantum-mirror.hu
          4 [PL] ftp.icm.edu.pl
          5 [US] mirrors.gigenet.com

--virtualbox-only Only downloads and installs VirtualBox.

--allow-errors

        Set dirty mode, don't quit on errors.

--no-show-errors

        Hide errors, do not print them.

--ci Set CI mode. Test running in CI.

--testers

        Set testers mode, testers version will be used.

-D, --dev

        Set development mode. Set default version to download empty
        image.

-d, --dry-run

        Set dry-run mode to emulate a run without doing anything relevant.

-t, --getopt

        Show parsed options and quit.

-V, --version

        Show version and quit.

-h, --help

        Show help for commands and quit.

EXAMPLES
Install Whonix Xfce for VirtualBox:

        $ installer-dist --guest=whonix --interface=xfce --hypervisor=kvm

Install default flavour making requests over onion and using SOCKS proxy:

        $ installer-dist --onion --socks-proxy=127.0.0.1:9050

Install default flavour and run without questions print info messages:

        $ installer-dist --non-interactive --log-level=info

EXIT CODES
An exit trap is set to return the exit code of the last command that was ran. Some commands might conflict with the script exit code, and that would be considered a bug. As curl and rsync are important to the script, its exit codes are reseverd to not conflict with the script exit code to ease debugging.

    1       Catchall for general errors.
    2       Unrecognized option usage.
    3-35    Rsync errors.
    3-96    Curl errors.
    100     User disagreed with the license.
    101     Unsupported system.
    102     Virtual machines already exist.
    103     Failed to download files.
    104     Failed cryptographic verification.
    105     Failed to import virtual machines.
    106     Failed to start virtual machines due to expected virtualization issues.
    107     Failed to start virtual machines due to unexpected issues.

AUTHOR
This man page was written by grass (grass@danwin1210.de).

WWW
https://www.whonix.org/wiki/Dev/Linux_Installer

SEE ALSO
curl(1), sha512sum(1), signify-openbsd(1), qemu(1), kvm(1)